;                        .
LIST P=16F84a
;    
#include "P16f84a.INC"
 __CONFIG    03FF1H
option_reg         equ           01h
tmr0               equ           01h
pcl                equ           02h
status             equ           03h
porta              equ           05h
portb              equ           06h
trisa              equ           05h
trisb              equ           06h
intcon             equ           0bh
eedata             equ           08h
eeadr              equ           09h
eecon1             equ           08h
eecon2             equ           09h
;
hour               equ           0dh
min                equ           0eh
sec                equ           0fh
v_1                equ           10h
v_2                equ           11h
temp1              equ           15h
p2                 equ           16h
flags_ind          equ           17h
out1               equ           20h 
out2               equ           21h
out3               equ           22h
out4               equ           23h
time               equ           24h
temp7              equ           25h
temp8              equ           26h
temp_w             equ           27h
temp_stat          equ           28h
flags              equ           29h
temp5              equ           2ah
ind1               equ           2dh
ind2               equ           2eh
;
                   org           2100h
                   de            70h,0d8h,00h,02h,d'59'
                   org           00h
                   goto          start
                   org           04h
                   movwf         temp_w
                   movf          status,0
                   movwf         temp_stat
                   bcf           status,5
                   movf          v_1,0
                   movwf         tmr0
                   clrf          portb
                   bsf           porta,3
                   decfsz        time,1
                   goto          int_m1
                   movf          v_2,0
                   movwf         time
                   btfsc         flags,0
                   goto          int_m2
                   bsf           flags,0
                   goto          int_m1
int_m2             bcf           flags,0
int_m1             btfss         flags_ind,6
                   goto          ind
int_exit           bcf           intcon,2
                   movf          temp_stat,0
                   movwf         status
                   bsf           flags,1
                   movf          temp_w,0
                   retfie
ind                movlw         b'00000011'
                   movwf         temp8
                   movlw         b'00001111'
                   movwf         temp7
                   movf          time,0
                   andwf         temp8,0
                   addwf         pcl,1
                   goto          ind_m1
                   goto          ind_m2
                   goto          ind_m3
;
                   btfsc         flags_ind,0
                   goto          ind_m_e
                   btfsc         flags_ind,2
                   goto          i_v4
                   movf          out4,1
                   btfsc         status,2
                   goto          i_m4_exit
                   bcf           flags_ind,5
i_v4               movf          out4,0
                   andwf         temp7,0
                   movwf         portb
                   bsf           portb,7
                   bsf           porta,3
                   goto          int_exit
i_m4_exit          bsf           flags_ind,5
                   clrf          portb
                   goto          int_exit
ind_m3             btfsc         flags_ind,0
                   goto          ind_m_e
                   btfsc         flags_ind,2
                   goto          i_v3
                   btfss         flags_ind,5
                   goto          i_m3_1
                   movf          out3,1
                   btfsc         status,2
                   goto          i_m3_exit
i_m3_1             bcf           flags_ind,4
i_v3               movf          out3,0
                   andwf         temp7,0
                   movwf         portb
                   bsf           portb,6
                   bsf           porta,3
                   call          i1
                   goto          int_exit
i_m3_exit          bsf           flags_ind,4
                   clrf          portb
                   goto          int_exit
i1                 btfss         flags_ind,7
                   goto          i11
                   bsf           porta,3
                   return
i11                bcf           porta,3
                   return
ind_m2             btfsc         flags_ind,1
                   goto          ind_m_e
                   movf          out2,0
                   andwf         temp7,0
                   movwf         portb
                   bsf           portb,5
                   bsf           porta,3
                   goto          int_exit
ind_m1             btfsc         flags_ind,1
                   goto          ind_m_e
                   movf          out1,0
                   andwf         temp7,0
                   movwf         portb
                   bsf           portb,4
                   bsf           porta,3
                   goto          int_exit
ind_m_e            clrf          portb
                   goto          int_exit
start              movlw         b'00000000'
                   movwf         intcon
                   bsf           status,5
                   movlw         b'10000011'
                   movwf         option_reg
                   movlw         b'11110011'
                   movwf         trisa
                   movlw         b'00000000'
                   movwf         trisb
                   bcf           status,5
                   movlw         70h
                   movwf         v_1
                   movlw         0d8h
                   movwf         v_2
                   movlw         02h         ; 
                   movwf         eeadr
                   bsf           status,5
                   bsf           eecon1,0
                   bcf           status,5
                   movf          eedata,0
                   movwf         hour
                   movlw         03h         ; 
                   movwf         eeadr
                   bsf           status,5
                   bsf           eecon1,0
                   bcf           status,5
                   movf          eedata,0
                   movwf         min
                   movlw         04h         ; 
                   movwf         eeadr
                   bsf           status,5
                   bsf           eecon1,0
                   bcf           status,5
                   movf          eedata,0
                   movwf         sec
                   movlw         00h
                   movwf         portb
                   bcf           porta,2
                   clrf          flags
                   clrf          flags_ind
                   bcf           porta,2
                   movlw         b'10100000'
                   movwf         intcon
m3                 btfss         porta,0
                   goto          m8
                   movf          hour,1
                   btfsc         status,2
                   goto          m8
                   call          convert1
m4                 btfss         flags,0
                   goto          b1
                   bsf           flags_ind,7
                   goto          b2
b1                 bcf           flags_ind,7
b2                 btfsc         flags,0
                   goto          m1
                   btfss         flags,2
                   goto          m2
                   bcf           flags,2
                   decf          sec,1
                   movf          sec,0
                   sublw         0ffh
                   btfss         status,2
                   goto          m3
                   movlw         d'59'
                   movwf         sec
                   decf          min,1
                   movf          min,0
                   sublw         0ffh
                   btfss         status,2
                   goto          m3
                   movlw         d'59'
                   movwf         min
                   decf          hour,1
                   movf          hour,0
                   sublw         0ffh
                   btfss         status,2
                   goto          m3
m7                 bsf           porta,2
                   btfsc         flags,0
                   goto          m5
                   bcf           flags_ind,6
                   goto          n1
m5                 bsf           flags_ind,6
n1                 btfsc         porta,1
                   goto          m7
                   movlw         20h
                   movwf         temp1
                   call          pause
                   btfsc         porta,1
                   goto          m7
a1                 btfss         porta,1
                   goto          a1
                   movlw         20h
                   movwf         temp1
                   call          pause
                   btfss         porta,1
                   goto          a1
                   goto          start
m1                 bsf           flags,2
                   goto          m2
m8                 call          convert2
                   goto          m4
convert1          ; bsf          flags_ind,6
                   call          m1_hl
                   movf          hour,0
                   movwf         temp5
                   call          b_d
                   movf          ind2,0
                   movwf         out3
                   movf          ind1,0
                   movwf         out4
;
                   movf          min,0
                   movwf         temp5
                   call          b_d
                   movf          ind2,0
                   movwf         out1
                   movf          ind1,0
                   movwf         out2
                   bcf           flags_ind,6
                   return
convert2          ; bsf          flags_ind,6
                   call          m1_hl
                   movf          min,0
                   movwf         temp5
                   call          b_d
                   movf          ind2,0
                   movwf         out3
                   movf          ind1,0
                   movwf         out4
;
                   movf          sec,0
                   movwf         temp5
                   call          b_d
                   movf          ind2,0
                   movwf         out1
                   movf          ind1,0
                   movwf         out2
                   bcf           flags_ind,6
                   return

; -----------      -----------

b_d  	           clrf 	 ind1
	           movf 	 temp5,0
	           movwf	 ind2
b_2	           movlw	 D'10'
	           subwf	 ind2,0
	           btfss	 status,0
	           goto	         b_1
	           movwf	 ind2
	           incf	         ind1,1
	           goto	         b_2
b_1	           movlw	 d'10'
	           subwf	 ind1,0
	           btfss         status,0
	           goto  	 b_3
	           movwf	 ind1
b_3	           return
pause              movlw         0ffh
                   movwf         p2
pause_1            decfsz        p2,1
                   goto          pause_1
                   decfsz        temp1,1
                   goto          pause
                   return
m1_hl              btfss         flags,0
                   goto          m1_hl1
                   bsf           flags,3
                   return
m1_hl1             bcf           flags,3
                   return
m2                 btfsc         porta,1
                   goto          m4
                   movlw         30h
                   movwf         temp1
                   call          pause
                   btfsc         porta,1
                   goto          m4
x1                 btfss         porta,1
                   goto          x1
                   movlw         30h
                   movwf         temp1
                   call          pause
                   btfss         porta,1
                   goto          x1
; 
                   bcf           porta,2
                   bsf           flags_ind,7
                   bcf           flags_ind,1
                   bsf           flags_ind,7
                   bcf           flags_ind,0
                   movlw         d'120'
                   movwf         v_2
                   call          convert1
x3                 btfss         porta,1
                   goto          y1
                   bsf           flags_ind,2
                   btfss         flags,0
                   goto          x2
                   bsf           flags_ind,0
                   btfss         porta,0
                   goto          x4
                   goto          x3
x2                 bcf           flags_ind,0
                   btfss         porta,0
                   goto          x4
                   goto          x3
x4                 bcf           flags_ind,0
                   call          xxx1
                   call          convert1
z1                 btfss         flags,0
                   goto          z2
                   btfss         porta,0
                   goto          z1
                   movlw         30h
                   movwf         temp1
                   call          pause
                   btfss         porta,0
                   goto          z1
                   goto          x3
x7                 btfsc         porta,0
                   goto          x3
                   btfsc         flags,0
                   goto          d1
                   btfss         flags,2
                   goto          d2
                   bcf           flags,2
                   goto          x3
d1                 btfsc         flags,2
                   goto          d2
                   bcf           flags,2
                   goto          x3
d2                 bsf           flags,2
                   call          xxx1
                   call          convert1
                   goto          x7
xxx1               incf          hour,1
                   movf          hour,0
                   sublw         d'100'
                   btfss         status,2
                   return
                   clrf          hour
                   return
z2                 bcf           flags,2
z7                 btfsc         porta,0
                   goto          z3
                   btfsc         flags,0
                   goto          z4
                   btfss         flags,2
                   goto          z7
                   goto          x7
z4                 bsf           flags,2
                   goto          z7
z3                 movlw         30h
                   movwf         temp1
                   call          pause
                   btfsc         porta,0
                   goto          x3
                   goto          z7
x9                 call          xxx1
                   call          convert1
                   goto          x7
; 
y1                 movlw         30h
                   movwf         temp1
                   call          pause
                   btfsc         porta,1
                   goto          x3
y2                 btfss         porta,1
                   goto          y2
                   movlw         30h
                   movwf         temp1
                   call          pause
                   btfss         porta,1
                   goto          y2
                   bsf           flags_ind,7
                   bcf           flags_ind,1
                   bsf           flags_ind,7
                   bcf           flags_ind,0
                   call          convert1
xx3                btfss         porta,1
                   goto          sy1
                   bsf           flags_ind,2
                   btfss         flags,0
                   goto          xx2
                   bsf           flags_ind,1
                   btfss         porta,0
                   goto          xx4
                   goto          xx3
xx2                bcf           flags_ind,1
                   btfss         porta,0
                   goto          xx4
                   goto          xx3
xx4                bcf           flags_ind,1
                   call          xxx2
                   call          convert1
zz1                btfss         flags,0
                   goto          zz2
                   btfss         porta,0
                   goto          zz1
                   movlw         30h
                   movwf         temp1
                   call          pause
                   btfss         porta,0
                   goto          zz1
                   goto          xx3
xx7                btfsc         porta,0
                   goto          xx3
                   btfsc         flags,0
                   goto          dd1
                   btfss         flags,2
                   goto          dd2
                   bcf           flags,2
                   goto          xx3
dd1                btfsc         flags,2
                   goto          dd2
                   bcf           flags,2
                   goto          xx3
dd2                bsf           flags,2
                   call          xxx2
                   call          convert1
                   goto          xx7
xxx2               incf          min,1
                   movf          min,0
                   sublw         d'60'
                   btfss         status,2
                   return
                   clrf          min
                   return
zz2                bcf           flags,2
zz7                btfsc         porta,0
                   goto          zz3
                   btfsc         flags,0
                   goto          zz4
                   btfss         flags,2
                   goto          zz7
                   goto          xx7
zz4                bsf           flags,2
                   goto          zz7
zz3                movlw         30h
                   movwf         temp1
                   call          pause
                   btfsc         porta,0
                   goto          xx3
                   goto          zz7
xx9                call          xxx2
                   call          convert1
                   goto          xx7
yy1                movlw         30h
                   movwf         temp1
                   call          pause
                   btfsc         porta,1
                   goto          xx3
yy2                btfss         porta,1
                   goto          yy2
                   movlw         30h
                   movwf         temp1
                   call          pause
                   btfss         porta,1
                   goto          yy2
; 
sy1                movlw         30h
                   movwf         temp1
                   call          pause
                   btfsc         porta,1
                   goto          x3
sy2                btfss         porta,1
                   goto          sy2
                   movlw         30h
                   movwf         temp1
                   call          pause
                   btfss         porta,1
                   goto          sy2
                   bsf           flags_ind,7
                   bcf           flags_ind,1
                   bsf           flags_ind,7
                   bcf           flags_ind,0
                   call          convert2
sx3                btfss         porta,1
                   goto          syy1
                   bsf           flags_ind,2
                   btfss         flags,0
                   goto          sx2
                   bsf           flags_ind,1
                   bsf           flags_ind,7
                   btfss         porta,0
                   goto          sx4
                   goto          sx3
sx2                bcf           flags_ind,1
                   bcf           flags_ind,7
                   btfss         porta,0
                   goto          sx4
                   goto          sx3
sx4                bcf           flags_ind,1
                   bcf           flags_ind,7
                   call          xxx3
                   call          convert2
sz1                btfss         flags,0
                   goto          sz2
                   btfss         porta,0
                   goto          sz1
                   movlw         30h
                   movwf         temp1
                   call          pause
                   btfss         porta,0
                   goto          sz1
                   goto          sx3
sx7                btfsc         porta,0
                   goto          sx3
                   btfsc         flags,0
                   goto          sd1
                   btfss         flags,2
                   goto          sd2
                   bcf           flags,2
                   goto          sx3
sd1                btfsc         flags,2
                   goto          sd2
                   bcf           flags,2
                   goto          sx3
sd2                bsf           flags,2
                   call          xxx3
                   call          convert2
                   goto          sx7
xxx3               incf          sec,1
                   movf          sec,0
                   sublw         d'60'
                   btfss         status,2
                   return
                   clrf          sec
                   return
sz2                bcf           flags,2
sz7                btfsc         porta,0
                   goto          sz3
                   btfsc         flags,0
                   goto          sz4
                   btfss         flags,2
                   goto          sz7
                   goto          sx7
sz4                bsf           flags,2
                   goto          sz7
sz3                movlw         30h
                   movwf         temp1
                   call          pause
                   btfsc         porta,0
                   goto          sx3
                   goto          sz7
sx9                call          xxx3
                   call          convert2
                   goto          sx7
syy1               movlw         30h
                   movwf         temp1
                   call          pause
                   btfsc         porta,1
                   goto          sx3
syy2               btfss         porta,1
                   goto          syy2
                   movlw         30h
                   movwf         temp1
                   call          pause
                   btfss         porta,1
                   goto          syy2
                   bcf           intcon,7
                   clrf          portb
                   bsf           porta,3
                   movlw         02h
                   movwf         eeadr
                   movf          hour,0
                   movwf         eedata
                   bsf           status,5
                   bsf           eecon1,2
                   movlw         055h
                   movwf         eecon2
                   movlw         0AAh
                   movwf         eecon2
                   bsf           eecon1,1
                   bcf           eecon1,4
                   bcf           status,5
                   movlw         50h
                   movwf         temp1
                   call          pause
;
                   bcf           intcon,7
                   movlw         03h
                   movwf         eeadr
                   movf          min,0
                   movwf         eedata
                   bsf           status,5
                   bsf           eecon1,2
                   movlw         055h
                   movwf         eecon2
                   movlw         0AAh
                   movwf         eecon2
                   bsf           eecon1,1
                   bcf           eecon1,4
                   bcf           status,5
                   movlw         50h
                   movwf         temp1
                   call          pause
;
                   bcf           intcon,7
                   movlw         04h
                   movwf         eeadr
                   movf          sec,0
                   movwf         eedata
                   bsf           status,5
                   bsf           eecon1,2
                   movlw         055h
                   movwf         eecon2
                   movlw         0AAh
                   movwf         eecon2
                   bsf           eecon1,1
                   bcf           eecon1,4
                   bcf           status,5
                   movlw         50h
                   movwf         temp1
                   call          pause
                   goto          start
                   end